<template>
  <BasicTable @register="registerTable" :rowSelection="rowSelection">
    <template #form-category="{ model, field }">
      <a-tree-select
        v-model:value="model[field]"
        show-search
        placeholder="请选择"
        allow-clear
        tree-default-expand-all
        :field-names="{ label: 'name', value: 'id', children: 'children' }"
        :tree-data="treeData"
        tree-node-filter-prop="label"
      >
        <template #suffixIcon>
          <SmileOutlined />
        </template>
      </a-tree-select>
    </template>
    <template #tableTitle>
      <a-button type="primary" preIcon="ant-design:export-outlined" v-auth="'tbgj-dc'" @click="onExportXls"> 导出</a-button>
      <a-button type="primary" preIcon="ant-design:export-outlined" v-auth="'tbgj-yczbsb'" @click="handleYczbsb"> 移出暂不上报名录</a-button>
    </template>
  </BasicTable>
</template>
<script setup lang="ts">
  import { BasicTable } from '@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';

  import { ColumnsNo, searchFormSchemaNo, useCategoryData } from './data';
  import { zbsbqd, zbsbqdExcel, yrzbsb } from './api';
  import { useMessage } from '/@/hooks/web/useMessage';

  const { createMessage } = useMessage();

  const { tableContext, onExportXls } = useListPage({
    tableProps: {
      title: '',
      api: zbsbqd,
      columns: ColumnsNo,
      canResize: false,
      rowSelection: { type: 'radio' },
      rowKey: 'wrdkid',
      clickToRowSelect: true,
      showActionColumn: false,
      beforeFetch(params: any) {
        if (params.data) {
          const arry = params.data.split(',');
          params.startTime = arry[0];
          params.endTime = arry[1];
        }
      },
      formConfig: {
        labelWidth: 120,
        schemas: searchFormSchemaNo,
        autoSubmitOnEnter: true,
        showAdvancedButton: false,
      },
      actionColumn: {
        width: 120,
        fixed: 'right',
      },
    },
    exportConfig: {
      name: '暂不上报名录',
      url: zbsbqdExcel,
    },
  });
  const [registerTable, { reload }, { rowSelection, selectedRows, selectedRowKeys }] = tableContext;
  const useCategory = useCategoryData();
  const treeData = useCategory.data; // 行业类别-数据
  const handleYczbsb = () => {
    if (selectedRows.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    yrzbsb({ wrdkid: selectedRows.value[0].wrdkid, zt: 0 })
      .then(() => {
        reload();
        message.success('移出成功');
      })
      .catch(() => {
        message.error('移出失败');
      });
  };
</script>
